RandomSortField (Solr 3.6.2 API)
Keywords: org.apache.solr.schema.RandomSortField class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.solr.schema
Class RandomSortField

    java.lang.Object
      org.apache.solr.schema.FieldProperties
          org.apache.solr.schema.FieldType
              org.apache.solr.schema.RandomSortField

    public class RandomSortField

extends FieldType

Utility Field used for random sorting. It should not be passed a value.

This random sorting implementation uses the dynamic field name to set the random 'seed'. To get random sorting order, you need to use a random dynamic field name. For example, you will need to configure schema.xml:

     <types>
      ...
      <fieldType name="random" class="solr.RandomSortField" />
      ...
     </types>
     <fields>
      ...
      <dynamicField name="random*" type="random" indexed="true" stored="false"/>
      ...
     </fields>

Examples of queries:

- http://localhost:8983/solr/select/?q=*:*&fl=name&sort=rand_1234%20desc
- http://localhost:8983/solr/select/?q=*:*&fl=name&sort=rand_2345%20desc
- http://localhost:8983/solr/select/?q=*:*&fl=name&sort=rand_ABDC%20desc
- http://localhost:8983/solr/select/?q=*:*&fl=name&sort=rand_21%20desc

Note that multiple calls to the same URL will return the same sorting order.

Since:
  solr 1.3
Version:
  $Id: RandomSortField.java 1136465 2011-06-16 14:50:22Z mikemccand $

Nested Class Summary
`class` | `RandomSortField.RandomValueSource`

Nested classes/interfaces inherited from class org.apache.solr.schema.FieldType
`FieldType.DefaultAnalyzer`

Field Summary

Fields inherited from class org.apache.solr.schema.FieldType
`analyzer, args, falseProperties, log, POLY_FIELD_SEPARATOR, queryAnalyzer, trueProperties, typeName`

Fields inherited from class org.apache.solr.schema.FieldProperties
`BINARY, INDEXED, MULTIVALUED, OMIT_NORMS, OMIT_POSITIONS, OMIT_TF_POSITIONS, REQUIRED, SORT_MISSING_FIRST, SORT_MISSING_LAST, STORE_TERMOFFSETS, STORE_TERMPOSITIONS, STORE_TERMVECTORS, STORED, TOKENIZED`

Constructor Summary
`RandomSortField()`

Method Summary
`SortField` | `getSortField(SchemaField field, boolean reverse)` Returns the SortField instance that should be used to sort fields of this type.
`ValueSource` | `getValueSource(SchemaField field, QParser parser)` called to get the default value source (normally, from the Lucene FieldCache.)
`void` | `write(TextResponseWriter writer, String name, Fieldable f)` calls back to TextResponseWriter to write the field value
`void` | `write(XMLWriter xmlWriter, String name, Fieldable f)` Renders the specified field as XML

Methods inherited from class org.apache.solr.schema.FieldType
`createField, createField, createFields, getAnalyzer, getArg, getFieldIndex, getFieldQuery, getFieldStore, getFieldTermVec, getIndexOptions, getQueryAnalyzer, getRangeQuery, getStringSort, getTypeName, getValueSource, hasProperty, indexedToReadable, init, isMultiValued, isPolyField, isTokenized, multiValuedFieldCache, readableToIndexed, restrictProps, setAnalyzer, setQueryAnalyzer, storedToIndexed, storedToReadable, toExternal, toInternal, toObject, toString`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### RandomSortField

    public RandomSortField()

Method Detail

### getSortField

    public SortField getSortField(SchemaField field,
                                  boolean reverse)

  Description copied from class: `FieldType`
  Returns the SortField instance that should be used to sort fields of this type.

  Specified by:
    `getSortField` in class `FieldType`
  See Also:
    `SchemaField.checkSortability()`

### getValueSource

    public ValueSource getValueSource(SchemaField field,
                                      QParser parser)

  Description copied from class: `FieldType`
  called to get the default value source (normally, from the Lucene FieldCache.)

  Overrides:
    `getValueSource` in class `FieldType`

### write

    public void write(XMLWriter xmlWriter,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  Renders the specified field as XML

  Specified by:
    `write` in class `FieldType`
  Throws:
    `IOException`

### write

    public void write(TextResponseWriter writer,
                      String name,
                      Fieldable f)
               throws IOException

  Description copied from class: `FieldType`
  calls back to TextResponseWriter to write the field value

  Specified by:
    `write` in class `FieldType`
  Throws:
    `IOException`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD